// ##################################################################
// ##### обработка полученных данных signal
// ##################################################################
function paramGetSignal() {
// console.log(tcc4_prev + ' ' + arr[4] + ' ' + G_REFRESH_F);
	var i = 0; // для организации цикла
	var temp = 0; // для временного хранения
	var temp1 = 0; // для временного хранения
	var temp2 = 0; // для временного хранения
	var temp3 = 0; // для временного хранения
	var temp4 = 0; // для временного хранения
	var arr = new Array();
	var inputType;
	var signalLength = 0; // длина буфера сигнала
	var signalSurveyPeriod = 0; // период следования точек в буфере сигнала
	var signalValue = 0;
	var arrVal_t = '';

	document.getElementById('id_signalInputNumber').value = G_arrValNumber; // номер inputX/varX для построения графика

	if (G_SKIP_ARRVAL_F > 0) { // ? 0 - не пропускать пакет с буфером "arrVal"; 1,2,3,... - пропустить;

		G_SKIP_ARRVAL_F++; // 0 - не пропускать пакет с буфером "arrVal"; 1 - пропустить;
		if (G_SKIP_ARRVAL_F >= 4) { // ? 0 - не пропускать пакет с буфером "arrVal"; 1,2,3,... - пропустить;
			G_SKIP_ARRVAL_F = 0; // 0 - не пропускать пакет с буфером "arrVal"; 1 - пропустить;
		}

		arrVal = '1,0000';
	}

	arr = arrVal.split(','); // arr[0] - содержит "input_0"; arr[1] - содержит "arrVal"

// ##### определяем тип входа
	temp = arr[0];
	inputType = temp & 0b0000000000001111; // выделяем место хранения
// console.log(inputType);
// end ##### определяем тип входа

	arrVal_t = arr[1];
// ##### есть данные для построения графика
	if (arrVal_t != '' && arrVal_t != undefined) {

		signalLength = arrVal_t.length; // длина строки arrVal
		signalLength = signalLength/4; // одна точка состоит из четырех символов

	// период опроса модуля
		temp = G_connectionCycle_c*G_CONNECTION_PERIOD + G_connectionPause*G_CONNECTION_PERIOD;
	// период следования точек в буфере сигнала (время между соседними точками)
		// SurveyPeriod
		signalSurveyPeriod = arr[0] >> 12; // сдвигаем из места хранения
		signalSurveyPeriod = signalSurveyPeriod & 0b0000000000001111; // выделяем место хранения

		switch (signalSurveyPeriod) {
			case 0: default:
				signalSurveyPeriod = 10;
				break;
			case 1:
				signalSurveyPeriod = 20;
				break;
			case 2:
				signalSurveyPeriod = 30;
				break;
			case 3:
				signalSurveyPeriod = 40;
				break;
			case 4:
				signalSurveyPeriod = 50;
				break;
			case 5:
				signalSurveyPeriod = 100;
				break;
			case 6:
				signalSurveyPeriod = 200;
				break;
			case 7:
				signalSurveyPeriod = 300;
				break;
			case 8:
				signalSurveyPeriod = 400;
				break;
			case 9:
				signalSurveyPeriod = 500;
				break;
			case 10:
				signalSurveyPeriod = 600;
				break;
			case 11:
				signalSurveyPeriod = 1000;
				break;
			case 12:
				signalSurveyPeriod = 2000;
				break;
			case 13:
				signalSurveyPeriod = 3000;
				break;
			case 14:
				signalSurveyPeriod = 4000;
				break;
			case 15:
				signalSurveyPeriod = 5000;
				break;
		}
// console.log(signalSurveyPeriod + ' ' + temp + ' ' + signalLength);

		// фиксируем время начала построения графика (к этому времени будем прибавлять "signalSurveyPeriod")
		temp4 = new Date().getTime() - parseInt(temp, 10);


		// проверка на переполнение буфера "arrVal"
		if (signalLength == 114) {
			document.getElementById('id_signalInfoMessage').innerHTML = 'Слишком большой период опроса.<br>Возможно неверное отображение сигнала на графике.';
		} else {
			// если буфер в пределах нормы (<114), то период расчитываем так, чтобы все точки поместились при построении графика (без наложения)
			document.getElementById('id_signalInfoMessage').innerHTML = '';
			signalSurveyPeriod = temp/signalLength;
			signalSurveyPeriod = signalSurveyPeriod.toFixed();
		}

	// ##### выводим принятый буфер на график
		for (i = 0; i < signalLength; i++) {
			temp1 = arrVal_t.substring((0+i*4), (2+i*4));
			temp1 = parseInt(temp1, 16);
			temp2 = arrVal_t.substring((2+i*4), (4+i*4));
			temp2 = parseInt(temp2, 16);
			temp3 = temp1*256 + temp2;
			signalValue = temp3;

			// inputType = 13 – DHT11;
			// inputType = 14 – DHT22;
			// inputType = 15 – DS18B20 (0x28);
			if (inputType == 13 || inputType == 14 || inputType == 15) {
				temp3 = (temp3 - 30000) / 100;
				signalValue = temp3;
			}


			temp4 = parseInt(temp4, 10) + parseInt(signalSurveyPeriod, 10);
			line1.append(temp4, signalValue);
// console.log(' period:' + temp + '/' + signalLength + '=' + signalSurveyPeriod + ' i=' + i + ' signal:' + signalValue + ' время:' + temp4);

		}
	// end ##### выводим принятый буфер на график

	// ##### отображаем последнее значение из принятого буфера
		// inputType = 13 – DHT11;
		// inputType = 14 – DHT22;
		if (inputType == 13 || inputType == 14 || inputType == 15) {
			if (G_arrValNumber == 5) {
				signalValue = temp3 + '&#176;C';
			}
			if (G_arrValNumber == 6) {
				signalValue = temp3 + '%';
			}
		}
		// inputType = 15 – DS18B20 (0x28);
		if (inputType == 15) {
			signalValue = temp3 + '&#176;C';
		}
		document.getElementById('id_signalValue').innerHTML = '<b>' + signalValue + '</b>';
	// end ##### отображаем последнее значение из принятого буфера

	}
// end ##### есть данные для построения графика

}
// ##################################################################
// end ##### обработка полученных данных signal
// ##################################################################



// ##################################################################
// ##### обработка полученных данных log
// ##################################################################
function paramGetLog() {
// console.log(tcc4_prev + ' ' + arr[4] + ' ' + G_REFRESH_F);
	var temp = 0; // для временного хранения
	var arr = new Array();

	arr = devStatus.split(',');


	temp = arr[2] & 0b0000000000000001; // отбрасываем все лишнее
	if (temp == 0) {
		document.getElementById('id_signalLog0').innerHTML = '<span style="color: Silver;">Ошибка инициализации радио-модуля WiFi</span>';
	} else {
		document.getElementById('id_signalLog0').innerHTML = '<span style="color: black;">Ошибка инициализации радио-модуля WiFi</span>';
	}

	temp = arr[2] & 0b0000000000000010; // отбрасываем все лишнее
	if (temp == 0) {
		document.getElementById('id_signalLog1').innerHTML = '<span style="color: Silver;">Ошибка передачи статуса устройства на сервер</span>';
	} else {
		document.getElementById('id_signalLog1').innerHTML = '<span style="color: black;">Ошибка передачи статуса устройства на сервер</span>';
	}

	temp = arr[2] & 0b0000000000000100; // отбрасываем все лишнее
	if (temp == 0) {
		document.getElementById('id_signalLog2').innerHTML = '<span style="color: Silver;">Ошибка перевода радио-модуля WiFi в sleep-режим</span>';
	} else {
		document.getElementById('id_signalLog2').innerHTML = '<span style="color: black;">Ошибка перевода радио-модуля WiFi в sleep-режим</span>';
	}

	temp = arr[2] & 0b0000000000001000; // отбрасываем все лишнее
	if (temp == 0) {
		document.getElementById('id_signalLog3').innerHTML = '<span style="color: Silver;">Ошибка запроса значения текущего времени</span>';
	} else {
		document.getElementById('id_signalLog3').innerHTML = '<span style="color: black;">Ошибка запроса значения текущего времени</span>';
	}
}
// ##################################################################
// end ##### обработка полученных данных log
// ##################################################################



// ##################################################################
// ##### обработка полученных данных: принудительное обновление
// ##################################################################
function paramGetRefresh() {
// console.log(tcc4_prev + ' ' + arr[4] + ' ' + G_REFRESH_F);
	G_REFRESH_F = 1; // 0 - нет обновления данных; 1 - обновление данных;
}
// ##################################################################
// end ##### обработка полученных данных: принудительное обновление
// ##################################################################



// ##################################################################
// ##### запись параметров
// ##################################################################
function paramSet(paramCode1, paramCode2, paramCode3) {
// console.log(paramCode1 + ' ' + paramCode2);
	var temp = 0; // для временного хранения

	if (paramCode1 == 'setting') {
		paramSetSetting(paramCode2);
	}

	if (paramCode1 == 'wifi') {
		paramSetWifi(paramCode2);
	}

	if (paramCode1 == 'tcc') {
		paramSetTcc(paramCode2);
	}

	if (paramCode1 == 'timer') {
		paramSetTimer(paramCode2, paramCode3);
	}

	if (paramCode1 == 'cron') {
		paramSetCron(paramCode2, paramCode3);
	}

	if (paramCode1 == 'input') {
		paramSetInput(paramCode2, paramCode3);
	}

	if (paramCode1 == 'out') {
		paramSetOut(paramCode2, paramCode3);
	}

	if (paramCode1 == 'flag') {
		paramSetFlag(paramCode2, paramCode3);
	}

	if (paramCode1 == 'var') {
		paramSetVar(paramCode2, paramCode3);
	}

	if (paramCode1 == 'condition') {
		paramSetCondition(paramCode2, paramCode3);
	}

	if (paramCode1 == 'act') {
		paramSetAct(paramCode2, paramCode3);
	}

	if (paramCode1 == 'arrValNum') {
		paramSetSignal();
	}

	if (paramCode1 == 'cmd') {
		cmdSet(paramCode2);
	}

	G_REFRESH_F = 1; // 0 - нет обновления данных; 1 - обновление данных;
}
// ##################################################################
// end ##### запись параметров
// ##################################################################



// ##################################################################
// ##### запись параметров paramSetSetting
// ##################################################################
function paramSetSetting(paramCode) {
// console.log(paramCode);
	var temp = 0; // для временного хранения
	var numberByte = 0; // номер байта
	var data = 0; // данные для отправки на устройство

// ##### setting_0
	if (paramCode == 'AdcRef' || paramCode == 'ServerType' || paramCode == 'OperWithoutPwdEn' || paramCode == 'GetTimeEn'
	|| paramCode == 'GMT_Value' || paramCode == 'WiFiRequestsNumber' || paramCode == 'WiFiRequestTimeout') {

	// AdcRef
		temp = document.getElementById('id_settingAdcRef').value;
		temp = parseInt(temp, 10); // преобразовываем строку в десятичное число
		temp = temp << 15;

		data = data + temp; // сохранили в отправляемом байте

	// ServerType
		temp = document.getElementById('id_settingServerType').value;
		temp = parseInt(temp, 10); // преобразовываем строку в десятичное число
		temp = temp << 12;

		data = data + temp; // сохранили в отправляемом байте

	// OperWithoutPwdEn
		temp = document.getElementById('id_settingOperWithoutPwdEn').value;
		temp = parseInt(temp, 10); // преобразовываем строку в десятичное число
		temp = temp << 11;

		data = data + temp; // сохранили в отправляемом байте

	// GetTimeEn
		temp = document.getElementById('id_settingGetTimeEn').value;
		temp = parseInt(temp, 10); // преобразовываем строку в десятичное число
		temp = temp << 10;

		data = data + temp; // сохранили в отправляемом байте

	// GMT_Value
		temp = document.getElementById('id_settingGMT_Value').value;
		temp = parseInt(temp, 10); // преобразовываем строку в десятичное число
		temp = temp & 0b0000000000011111; // выделяем место хранения
		temp = temp << 5;

		data = data + temp; // сохранили в отправляемом байте

	// settingWiFiRequestsNumber
		temp = document.getElementById('id_settingWiFiRequestsNumber').value;
		temp = parseInt(temp, 10); // преобразовываем строку в десятичное число
		temp = temp & 0b0000000000000011; // выделяем место хранения
		temp = temp << 2;

		data = data + temp; // сохранили в отправляемом байте

	// settingWiFiRequestTimeout
		temp = document.getElementById('id_settingWiFiRequestTimeout').value;
		temp = parseInt(temp, 10); // преобразовываем строку в десятичное число
		temp = temp & 0b0000000000000011; // выделяем место хранения

		data = data + temp; // сохранили в отправляемом байте

		numberByte = 0; // номер байта
	}
// end ##### setting_0

// ##### setting_1
	if (paramCode == 'ServerIp') {
		
	// ServerIp
		temp = document.getElementById('id_settingServerIp').value;

		data = temp; // сохранили в отправляемом байте

		numberByte = 1; // номер байта
	}
// end ##### setting_1

// ##### setting_2
	if (paramCode == 'ServerPort') {
		
	// ServerPort
		temp = document.getElementById('id_settingServerPort').value;

		data = temp; // сохранили в отправляемом байте

		numberByte = 2; // номер байта
	}
// end ##### setting_2

	G_sendParam = 'set/?setting_' + numberByte + '=' + data;
}
// ##################################################################
// end ##### запись параметров paramSetSetting
// ##################################################################



// ##################################################################
// ##### запись параметров wifi
// ##################################################################
function paramSetWifi(paramCode) {
// console.log(paramCode);
	var wifi_0 = document.getElementById('id_wifiAccessPointSSID').value;
	var wifi_1 = document.getElementById('id_wifiAccessPointPWD').value;
	var wifi_2 = document.getElementById('id_wifiLocalSSID').value;
	var wifi_3 = document.getElementById('id_wifiLocalPWD').value;
	var wifi_4 = document.getElementById('id_wifiLocalIp').value;
	var wifi_5 = document.getElementById('id_wifiLocalIpGate').value;
	var wifi_6 = document.getElementById('id_wifiLocalIpMask').value;

	if (paramCode == 'param_0_6') {
		G_sendParam = 'set/?wifi_0=' + wifi_0 + '&wifi_1=' + wifi_1 + '&wifi_4=' + wifi_4 + '&wifi_5=' + wifi_5 + '&wifi_6=' + wifi_6;
	}

	if (paramCode == 'param_2_3') {
		G_sendParam = 'set/?wifi_2=' + wifi_2 + '&wifi_3=' + wifi_3;
	}
}
// ##################################################################
// end ##### запись параметров wifi
// ##################################################################



// ##################################################################
// ##### запись параметров tcc
// ##################################################################
function paramSetTcc(paramCode) {

	var temp = 0; // для временного хранения

	if (paramCode == 'hour') {
		G_sendParam = 'set/?tcc_hour=' + document.getElementById('id_calendarHour').value;
	}

	if (paramCode == 'minute') {
		G_sendParam = 'set/?tcc_min=' + document.getElementById('id_calendarMinute').value;
	}

	if (paramCode == 'seconds') {
		G_sendParam = 'set/?tcc_sec=' + document.getElementById('id_calendarSeconds').value;
	}

	if (paramCode == 'weekDay') {
		G_sendParam = 'set/?tcc_weekday=' + document.getElementById('id_calendarDayWeek').value;
	}

	if (paramCode == 'corrSeconds') {
		G_sendParam = 'set/?tcc_corr=' + document.getElementById('id_calendCorrSeconds').value;
	}

	if (paramCode == 'sync') {
		var temp = new Date();
	//	var dateYear = (temp.getFullYear());
	//	var dateMonth = (temp.getMonth()) + 1; // 0-11
	//	var dateDate = temp.getDate();
		var dateDay = temp.getDay();
		// корректируем "Day", т.к. 0-вс...6-сб, а надо 0-пн...6-вс

		var timeHour = temp.getHours();
		var timeMinutes = temp.getMinutes();
		var timeSeconds = temp.getSeconds();

		G_sendParam = 'set/?' + "tcc_weekday=" + dateDay + '&tcc_hour=' + timeHour + '&tcc_min=' + timeMinutes + '&tcc_sec=' + timeSeconds;
	}
}
// ##################################################################
// end ##### запись параметров tcc
// ##################################################################



// ##################################################################
// ##### запись параметров timer
// ##################################################################
function paramSetTimer(paramCode1, paramCode2) {

	var temp = 0; // для временного хранения
	var temp1 = 0; // для временного хранения

	if (paramCode1 == 'Type') {
		temp = 'timer' + paramCode2 + '_0=' + document.getElementById('id_timer' + paramCode2 + '_Type').value;
	}

	if (paramCode1 == 'Delay') {
		temp = document.getElementById('id_timer' + paramCode2 + '_80').value;
		if (document.getElementById('id_timer' + paramCode2 + '_80_range').value == 0) {
			temp = parseInt(temp, 10)/10; // для диапазона отсчета "мс" корректируем значнение
		}

		// проверка на переполнение
		if (temp > 16382) {
			temp = 16382;
		}

		// размещаем "диапазон отсчета "значение таймера" (мин, сек, мс)"
		temp1 = document.getElementById('id_timer' + paramCode2 + '_80_range').value << 14; // сдвигаем в место хранения
		// комбинируем "диапазон отсчета" и "значение"
		temp1 = parseInt(temp1, 10) + parseInt(temp, 10);

		temp = 'timer' + paramCode2 + '_80=' + temp1;
	}

	if (paramCode1 == 'ActTime') {
		temp = document.getElementById('id_timer' + paramCode2 + '_203').value;
		if (document.getElementById('id_timer' + paramCode2 + '_203_range').value == 0) {
			temp = parseInt(temp, 10)/10; // для диапазона отсчета "мс" корректируем значнение
		}

		// проверка на переполнение
		if (temp > 16382) {
			temp = 16382;
		}

		// размещаем "диапазон отсчета "значение таймера" (мин, сек, мс)"
		temp1 = document.getElementById('id_timer' + paramCode2 + '_203_range').value << 14; // сдвигаем в место хранения
		// комбинируем "диапазон отсчета" и "значение"
		temp1 = parseInt(temp1, 10) + parseInt(temp, 10);

		temp = 'timer' + paramCode2 + '_203=' + temp1;
	}

	if (paramCode1 == 'Ctrl') {
		if (document.getElementById('id_timer' + paramCode2 + '_Ctrl').checked == true) {
			temp1 = 1;
		} else {
			temp1 = 0;
		}

		temp = 'timer' + paramCode2 + '_ctrl=' + temp1;
	}

	G_sendParam = "set/?" + temp;
}
// ##################################################################
// end ##### запись параметров timer
// ##################################################################



// ##################################################################
// ##### запись параметров cron
// ##################################################################
function paramSetCron(paramCode1, paramCode2) {

	var temp = 0; // для временного хранения
	var temp1 = 0; // для временного хранения

	if (paramCode1 == 'HourOn') {
		temp = 'cron' + paramCode2 + '_hour=' + document.getElementById('id_cron' + paramCode2 + '_0').value;
	}

	if (paramCode1 == 'MinuteOn') {
		temp = 'cron' + paramCode2 + '_min=' + document.getElementById('id_cron' + paramCode2 + '_1').value;
	}

// PwrOn как id_cron1_40_7
	if (paramCode1 == 'DayWeekOn') {
		for (i = 0; i < 8; i++) {
			if (document.getElementById('id_cron' + paramCode2 + '_40_' + i).checked == true) {
				temp1 = temp1 + Math.pow(2,i); // 2^i
			}
		}

		temp = 'cron' + paramCode2 + '_weekday=' + temp1;
	}

	if (paramCode1 == 'ActTime') {
		temp = document.getElementById('id_cron' + paramCode2 + '_203').value;
		if (document.getElementById('id_cron' + paramCode2 + '_203_range').value == 0) {
			temp = parseInt(temp, 10)/10; // для диапазона отсчета "мс" корректируем значнение
		}

		// проверка на переполнение
		if (temp > 16382) {
			temp = 16382;
		}

		// размещаем "диапазон отсчета "значение таймера" (мин, сек, мс)"
		temp1 = document.getElementById('id_cron' + paramCode2 + '_203_range').value << 14; // сдвигаем в место хранения
		// комбинируем "диапазон отсчета" и "значение"
		temp1 = parseInt(temp1, 10) + parseInt(temp, 10);

		temp = 'cron' + paramCode2 + '_203=' + temp1;
	}

	if (paramCode1 == 'Ctrl') {
		if (document.getElementById('id_cron' + paramCode2 + '_Ctrl').checked == true) {
			temp1 = 1;
		} else {
			temp1 = 0;
		}

		temp = 'cron' + paramCode2 + '_ctrl=' + temp1;
	}

	G_sendParam = "set/?" + temp;
}
// ##################################################################
// end ##### запись параметров cron
// ##################################################################



// ##################################################################
// ##### запись параметров input
// ##################################################################
function paramSetInput(paramCode1, paramCode2) {

	var data = 0; // данные для отправки на устройство
	var temp = 0; // для временного хранения
	var numberByte = 0; // номер байта
	var inputType = 0; // тип

	inputType = document.getElementById('id_input' + paramCode2 + '_Type').value;

// ##### Byte0
	if (paramCode1 == 'SurveyPeriod' || paramCode1 == 'TpulseRange' || paramCode1 == 'ThresholdTime' || paramCode1 == 'Filter' || paramCode1 == 'PullResistance' || paramCode1 == 'Type') {

	// inputSurveyPeriod
		// inputType = 1 – цифровой;
		// inputType = 2 – цифровой invert (с инверсией);
		// inputType = 12 – аналоговый (AN) (inputPullResistance=0 (00) – не используется);
		// inputType = 13 – DHT11;
		// inputType = 14 – DHT22;
		// inputType = 15 – DS18B20 (0x28);
		if (inputType == 1 || inputType == 2 || inputType == 12 || inputType == 13 || inputType == 14 || inputType == 15) {
			temp = document.getElementById('id_input' + paramCode2 + '_SurveyPeriod').value;
			temp = parseInt(temp, 10); // преобразовываем строку в десятичное число
			temp = temp << 12; // сдвигаем на место хранения

			data = data + temp; // сохранили в отправляемом байте
		}
	// end inputSurveyPeriod

	// inputTpulseRange
		// только input2
		// inputType = 5 – детектор нуля (220В) __/**;
		// inputType = 6 – детектор нуля (220В) **\__;
		// inputType = 7 – измерение длительности импульса __/**\__;
		// inputType = 8 – измерение длительности импульса **\__/**;
		if (inputType == 5 || inputType == 6 || inputType == 7 || inputType == 8) {
			temp = document.getElementById('id_input' + paramCode2 + '_TpulseRange').value;
			temp = parseInt(temp, 10); // преобразовываем строку в десятичное число
			temp = temp << 12; // сдвигаем на место хранения

			data = data + temp; // сохранили в отправляемом байте
		}
	// end inputTpulseRange

	// inputThresholdTime
		// inputType = 1 – цифровой;
		// inputType = 2 – цифровой invert (с инверсией);
		if (inputType == 1 || inputType == 2) {
			temp = document.getElementById('id_input' + paramCode2 + '_ThresholdTime').value;
			temp = parseInt(temp, 10); // преобразовываем строку в десятичное число
			// проверка на переполнение
			if (temp <= 0) {
				temp = 1;
			}
			if (temp > 64) {
				temp = 64;
			}
			temp = temp - 1; // приводим к диапазону 0...63
			temp = temp << 6; // сдвигаем на место хранения

			data = data + temp; // сохранили в отправляемом байте
		}
	// end inputThresholdTime

	// inputFilter
		// inputType = 5 – детектор нуля (220В) __/**;
		// inputType = 6 – детектор нуля (220В) **\__;
		// inputType = 7 – измерение длительности импульса __/**\__;
		// inputType = 8 – измерение длительности импульса **\__/**;
		// inputType = 12 – аналоговый (AN) (inputPullResistance=0 (00) – не используется);
		// inputType = 13 – DHT11;
		// inputType = 14 – DHT22;
		// inputType = 15 – DS18B20 (0x28);
		if (inputType == 5 || inputType == 6 || inputType == 7 || inputType == 8 || inputType == 12 || inputType == 13 || inputType == 14 || inputType == 15) {
			temp = document.getElementById('id_input' + paramCode2 + '_Filter').value;
			temp = parseInt(temp, 10); // преобразовываем строку в десятичное число
			temp = temp << 6; // сдвигаем на место хранения

			data = data + temp; // сохранили в отправляемом байте
		}
	// end inputFilter

	// inputPullResistance
		temp = document.getElementById('id_input' + paramCode2 + '_PullResistance').value;
		temp = parseInt(temp, 10); // преобразовываем строку в десятичное число
		temp = temp << 4; // сдвигаем на место хранения

		data = data + temp; // сохранили в отправляемом байте
	// end inputPullResistance

	// inputType
		temp = document.getElementById('id_input' + paramCode2 + '_Type').value;
		temp = parseInt(temp, 10); // преобразовываем строку в десятичное число

		data = data + temp; // сохранили в отправляемом байте
	// end inputType

		numberByte = 0; // номер байта
	}

// ##### Byte1
	if (paramCode1 == 'RepeatTime' || paramCode1 == 'HoldTime' || paramCode1 == 'DoubleClickTime') {

	// inputRepeatTime
		temp = document.getElementById('id_input' + paramCode2 + '_RepeatTime').value;
		temp = parseInt(temp, 10); // преобразовываем строку в десятичное число
		temp = temp << 12; // сдвигаем на место хранения

		data = data + temp; // сохранили в отправляемом байте
	// end inputRepeatTime

	// inputHoldTime
		temp = document.getElementById('id_input' + paramCode2 + '_HoldTime').value;
		temp = parseInt(temp, 10); // преобразовываем строку в десятичное число
		temp = temp << 10; // сдвигаем на место хранения

		data = data + temp; // сохранили в отправляемом байте
	// end inputHoldTime

	// inputDoubleClickTime
		temp = document.getElementById('id_input' + paramCode2 + '_DoubleClickTime').value;
		temp = parseInt(temp, 10); // преобразовываем строку в десятичное число
		temp = temp << 8; // сдвигаем на место хранения

		data = data + temp; // сохранили в отправляемом байте
	// end inputDoubleClickTime

		numberByte = 1; // номер байта
	}

	G_sendParam = 'set/?input' + paramCode2 + '_' + numberByte + '=' + data;
}
// ##################################################################
// end ##### запись параметров input
// ##################################################################



// ##################################################################
// ##### запись параметров out
// ##################################################################
function paramSetOut(paramCode1, paramCode2) {

	var data = 0; // данные для отправки на устройство
	var temp = 0; // для временного хранения
	var temp1 = 0; // для временного хранения
	var numberByte = 0; // номер байта

// ##### output0
	if (paramCode1 == 'Type' || paramCode1 == 'Invert' || paramCode1 == 'PwrOn' || paramCode1 == 'ScaleMode') {

	// Type
		temp = document.getElementById('id_output' + paramCode2 + '_Type').value;
		temp = parseInt(temp, 10); // преобразовываем строку в десятичное число

		data = data + temp; // сохранили в отправляемом байте
	// end Type

	// Invert
		if (document.getElementById('id_output' + paramCode2 + '_Invert').checked == true) {
			temp = 1;
		} else {
			temp = 0;
		}
		temp = temp << 4; // сдвигаем на место хранения
// console.log(temp);
		data = data + temp; // сохранили в отправляемом байте
	// end Invert

	// PwrOn
		if (document.getElementById('id_output' + paramCode2 + '_PwrOn').checked == true) {
			temp = 1;
		} else {
			temp = 0;
		}
		temp = temp << 5; // сдвигаем на место хранения
// console.log(temp);
		data = data + temp; // сохранили в отправляемом байте
	// end PwrOn

	// ScaleMode
		// определяем Type (PWM или WS)
		temp1 = document.getElementById('id_output' + paramCode2 + '_Type').value;
		temp1 = parseInt(temp1, 10); // преобразовываем строку в десятичное число

		// 10 – PWM ws2812b
		// 11 – PWM ws2811
		// 12 – PWM sk6812 (24бит)
		// 13 – PWM sk6812 (32бит)
		if (temp1 == 10 || temp1 == 11 || temp1 == 12 || temp1 == 13) {
			temp = document.getElementById('id_output' + paramCode2 + '_ScaleMode').value;
			temp = parseInt(temp, 10); // преобразовываем строку в десятичное число

			temp = temp << 6; // сдвигаем на место хранения

			data = data + temp; // сохранили в отправляемом байте
		}
	// end ScaleMode

		numberByte = 0; // номер байта
	}
// end ##### output0

// ##### output1
	if (paramCode1 == 'PwmFreq') {

	// PwmFreq
		temp = document.getElementById('id_output' + paramCode2 + '_PwmFreq').value;
		temp = parseInt(temp, 10); // преобразовываем строку в десятичное число
		// проверка на переполнение
		if (temp > 0) {
			temp = temp;
		} else {
			temp = 0;
		}
		if (temp > 255) {
			temp = 255;
		}

		data = data + temp; // сохранили в отправляемом байте
	// end PwmFreq

		numberByte = 1; // номер байта
	}

	if (paramCode1 == 'CorrectBegin' || paramCode1 == 'CorrectEnd') {
	// CorrectBegin
		temp = document.getElementById('id_output' + paramCode2 + '_CorrectBegin').value;
		temp = parseInt(temp, 10); // преобразовываем строку в десятичное число
		temp = temp << 4; // сдвигаем на место хранения

		data = data + temp; // сохранили в отправляемом байте
	// end CorrectBegin

	// CorrectEnd
		temp = document.getElementById('id_output' + paramCode2 + '_CorrectEnd').value;
		temp = parseInt(temp, 10); // преобразовываем строку в десятичное число

		data = data + temp; // сохранили в отправляемом байте
	// end CorrectEnd

		numberByte = 1; // номер байта
	}

	if (paramCode1 == 'LedCount') {

		temp = document.getElementById('id_output' + paramCode2 + '_LedCount').value;
		temp = parseInt(temp, 10); // преобразовываем строку в десятичное число
		// проверка на переполнение
		if (temp > 255) {
			temp = 255;
		}

		data = data + temp; // сохранили в отправляемом байте
	// end LedCount

		numberByte = 1; // номер байта
	}
// end ##### output1

// ##### output2
	if (paramCode1 == 'DutyCycle') {

	// DutyCycle
		temp = document.getElementById('id_output' + paramCode2 + '_DutyCycle').value;
		temp = parseInt(temp, 10); // преобразовываем строку в десятичное число

		data = data + temp; // сохранили в отправляемом байте
	// end DutyCycle

		numberByte = 2; // номер байта
	}
// end ##### output2

// ##### output3
	if (paramCode1 == 'RateOfChange') {

	// RateOfChange
		temp = document.getElementById('id_output' + paramCode2 + '_RateOfChange').value;
		temp = parseInt(temp, 10); // преобразовываем строку в десятичное число

		// определяем Type (PWM или WS)
		temp1 = document.getElementById('id_output' + paramCode2 + '_Type').value;
		temp1 = parseInt(temp1, 10); // преобразовываем строку в десятичное число

		if (document.getElementById('id_output' + paramCode2 + '_RateOfChangeRange').value == 0) { // мс
		}

		if (document.getElementById('id_output' + paramCode2 + '_RateOfChangeRange').value == 1) { // сек
			temp = temp * 1000; // 1сек = 1000мс
		}

		if (document.getElementById('id_output' + paramCode2 + '_RateOfChangeRange').value == 2) { // мин
			temp = temp * 60000; // 1мин = 60000мс
		}
// console.log(temp);
		// 3 – PWM (ШИМ)
		// 4 – PWM invert (с инверсией)
		// 10 – PWM ws2812b
		// 10 – PWM ws2811
		// 12 – PWM sk6812 (24бит)
		// 13 – PWM sk6812 (32бит)
		if (temp1 == 3 || temp1 == 4 || temp1 == 10 || temp1 == 11 || temp1 == 12 || temp1 == 13) {
			temp = temp / 100;
			temp = temp.toFixed(0);
		}
		// 5 – SERVO (управление серводвигателями);
		// 6 – SERVO invert (с инверсией);
		if (temp1 == 5 || temp1 == 6) {
			temp = temp / 250;
			temp = temp.toFixed(0);
		}

		// проверка на переполнение
		if (temp > 65535) {
			temp = 65535;
		}

		data = data + temp; // сохранили в отправляемом байте
	// end RateOfChange

		numberByte = 3; // номер байта
	}
// end ##### output3

// ##### outputCtrl
	if (paramCode1 == 'Ctrl') {

	// Ctrl
		if (document.getElementById('id_output' + paramCode2 + '_Ctrl').checked == true) {
			temp = 1;
		} else {
			temp = 0;
		}

		data = data + temp; // сохранили в отправляемом байте
	// end Ctrl

		numberByte = 'ctrl'; // номер байта
	}
// end ##### outputCtrl

	G_sendParam = 'set/?out' + paramCode2 + '_' + numberByte + '=' + data;
}
// ##################################################################
// end ##### запись параметров out
// ##################################################################



// ##################################################################
// ##### запись параметров flag
// ##################################################################
function paramSetFlag(paramCode1, paramCode2) {
// console.log(paramCode1 + ' ' + paramCode2);
	var data = 0; // данные для отправки на устройство
	var temp = 0; // для временного хранения
	var numberByte = 0; // номер байта

// ##### flagCtrl
	if (paramCode1 == 'Ctrl') {

	// Ctrl
		if (document.getElementById('id_flag' + paramCode2 + '_Ctrl').checked == true) {
			temp = 1;
		} else {
			temp = 0;
		}

		data = data + temp; // сохранили в отправляемом байте
	// end Ctrl

		numberByte = 'ctrl'; // номер байта
	}
// end ##### flagCtrl

	G_sendParam = 'set/?flag' + paramCode2 + '_' + numberByte + '=' + data;
}
// ##################################################################
// end ##### запись параметров flag
// ##################################################################



// ##################################################################
// ##### запись параметров var
// ##################################################################
function paramSetVar(paramCode1, paramCode2) {
// console.log(paramCode1 + ' ' + paramCode2);
	var data = 0; // данные для отправки на устройство
	var temp = 0; // для временного хранения
	var numberByte = 0; // номер байта

// ##### variable80
	if (paramCode1 == 'Value') {

	// Value
		temp = document.getElementById('id_variable' + paramCode2 + '_Value').value;
		temp = parseInt(temp, 10); // преобразовываем строку в десятичное число
		// проверка на переполнение
		if (temp > 65535) {
			temp = 65535;
		}

		data = data + temp; // сохранили в отправляемом байте
	// end Value

		numberByte = 'val'; // номер байта
	}
// end ##### variable80

	G_sendParam = 'set/?var' + paramCode2 + '_' + numberByte + '=' + data;
}
// ##################################################################
// end ##### запись параметров var
// ##################################################################



