
// ##### пользовательские настройки


// ##################################################################
// ##### преобразование входных значений для поля "Значение" и описание параметров
// ##################################################################
function userSettings() {



	input0_conv = input0_val;
	input1_conv = input1_val;
	input2_conv = input2_val;
	input3_conv = input3_val;
	input4_conv = input4_val;
	input5_conv = input5_val;
	input6_conv = input6_val;

	var0_conv = var0_val;
	var1_conv = var1_val;
	var2_conv = var2_val;
	var3_conv = var3_val;
	var4_conv = var4_val;
	var5_conv = var5_val;
	var6_conv = var6_val;
	var7_conv = var7_val;



// ##### настройки, зависящие от IP-адреса
	if (G_sendIP == '192.168.1.250') {

	// ##### ПАРОЛЬ "ОПЕРАТОР"
		// если passwordOperator='', то пароль необходимо вводить вручную
		userDesc_passwordOperator = '';
	// end ##### ПАРОЛЬ "ОПЕРАТОР"

	// ##### ПЕРОБРАЗОВАНИЕ ЦИФРОВОГО КОДА ВХОДОВ

		// переменная inputX_val содержит цифровой код входа inputX (где Х - номер входа, 0...6)
		// переменная inputX_conv должна содержать результат операции с участием переменной inputX_val

		// примеры перобразования цифрового кода в зависимости от типа входа:

		// ##### Цифровой
		// ##### Цифровой (инверсия)
			//  inputX_conv = inputX_val;
		// или можно использовать символьное обозначение, как показано ниже
			//	if (inputX_val == 0) {
			//		inputX_conv = 'ОТКЛЮЧЕНО'; // или 'OFF'
			//	}
			//	if (inputX_val == 1) {
			//		inputX_conv = 'ВКЛЮЧЕНО'; // или 'ON'
			//	}

		// ##### Аналоговый
		// «Опорное напряжение: 3,3В»:
			// inputX_conv = ((inputX_val*3.3)/4096) + ' В';
		// «Опорное напряжение: 2,3В»:
			// inputX_conv = ((inputX_val*2.3)/4096) + ' В';
		// дополнительно можно округлить показания, отбросив лишние знаки после запятой
			// inputX_conv = inputX_conv.toFixed(2) // оставляем только два знака после запятой

		// ##### DS18B20: температура
		// ##### DHT11: температура
		// ##### DHT22: температура
			// inputX_conv = ((inputX_val - 30000) / 100) + '&#176;C';

		// ##### DHT11: влажность
		// ##### DHT22: влажность
			// inputX_conv = ((inputX_val - 30000) / 100) + '%';

		// ##### Счетчик __/**
		// ##### Счетчик **\__)
		//  inputX_conv = inputX_val;

		// ##### Дет.нуля (220В)__/** (Дет.нуля (220В)**\__)
		//  inputX_conv = inputX_val;

		// ##### Изм.длит.имп.__/**\__ (Изм.длит.имп.**\__/**)
		// «Шаг измерения» = 62,5нс:
		// inputX_conv = (inputX_val*62.5) + ' нс';
		// «Шаг измерения» = 0,5мкс:
		// inputX_conv = (inputX_val*0.5) + ' мкс';
		// «Шаг измерения» = 4мкс:
		// inputX_conv = (inputX_val*4) + ' мкс';
		// «Шаг измерения» = 16мкс:
		// inputX_conv = (inputX_val*16) + ' мкс';

		// !!!!! СИМВОЛ 'X' ОБЯЗАТЕЛЬНО ЗАМЕНИТЬ НА СООТВЕТСТВУЮЩИЙ НОМЕР ВХОДА (0...6) !!!!!

		// ##### input0
		input0_conv = input0_val;

		// ##### input1
		input1_conv = input1_val;

		// ##### input2
		input2_conv = input2_val;

		// ##### input3
		input3_conv = input3_val;

		// ##### input4
		input4_conv = input4_val;

		// ##### input5
		input5_conv = input5_val;

		// ##### input6
		input6_conv = input6_val;

	// end ##### ПЕРОБРАЗОВАНИЕ ЦИФРОВОГО КОДА ВХОДОВ



	// ##### ПЕРОБРАЗОВАНИЕ ЦИФРОВОГО КОДА ПЕРЕМЕННЫХ

		// ##### var0
		var0_conv = var0_val;

		// ##### var1
		var1_conv = var1_val;

		// ##### var2
		var2_conv = var2_val;

		// ##### var3
		var3_conv = var3_val;

		// ##### var4
		var4_conv = var4_val;

		// ##### var5
		var5_conv = var5_val;

		// ##### var6
		var6_conv = var6_val;

		// ##### var7
		var7_conv = var7_val;

	// end ##### ПЕРОБРАЗОВАНИЕ ЦИФРОВОГО КОДА ПЕРЕМЕННЫХ



	// ##### ОПИСАНИЕ ПАРАМЕТРОВ

		userDesc_Input[0] = ''; // вход 0
		userDesc_Input[1] = ''; // вход 1
		userDesc_Input[2] = ''; // вход 2
		userDesc_Input[3] = ''; // вход 3
		userDesc_Input[4] = ''; // вход 4
		userDesc_Input[5] = ''; // вход 5
		userDesc_Input[6] = ''; // вход 6

		userDesc_Out[0] = ''; // выход 0
		userDesc_Out[1] = ''; // выход 1
		userDesc_Out[2] = ''; // выход 2
		userDesc_Out[3] = ''; // выход 3
		userDesc_Out[4] = ''; // выход 4
		userDesc_Out[5] = ''; // выход 5

		userDesc_Flag[0] = ''; // флаг 0
		userDesc_Flag[1] = ''; // флаг 1
		userDesc_Flag[2] = ''; // флаг 2
		userDesc_Flag[3] = ''; // флаг 3
		userDesc_Flag[4] = ''; // флаг 4
		userDesc_Flag[5] = ''; // флаг 5

		userDesc_Cron[0] = ''; // будильник 0
		userDesc_Cron[1] = ''; // будильник 1

		userDesc_Var[0] = ''; // переменная 0
		userDesc_Var[1] = ''; // переменная 1
		userDesc_Var[2] = ''; // переменная 2
		userDesc_Var[3] = ''; // переменная 3
		userDesc_Var[4] = ''; // переменная 4
		userDesc_Var[5] = ''; // переменная 5
		userDesc_Var[6] = ''; // переменная 6
		userDesc_Var[7] = ''; // переменная 7

	// end ##### ОПИСАНИЕ ПАРАМЕТРОВ



	// ##### СПИСОК IP-АДРЕСОВ

		// если переменная userValue_IPaddress[x]='', строка с заданными IP-адреса и описанием IP-адреса не создается

		userValue_IPaddress[0] = '192.168.1.50'; // IP-адрес 0: значение (например: 192.168.1.50)
		userDesc_IPaddress[0] = 'Кухня'; // IP-адрес 0: описание (например: "Кухня")

		userValue_IPaddress[1] = '192.168.1.50'; // IP-адрес 1
		userDesc_IPaddress[1] = 'Спальня'; // IP-адрес 1

		userValue_IPaddress[2] = ''; // IP-адрес 2
		userDesc_IPaddress[2] = ''; // IP-адрес 2

		userValue_IPaddress[3] = ''; // IP-адрес 3
		userDesc_IPaddress[3] = ''; // IP-адрес 3

		userValue_IPaddress[4] = ''; // IP-адрес 4
		userDesc_IPaddress[4] = ''; // IP-адрес 4

		userValue_IPaddress[5] = ''; // IP-адрес 5
		userDesc_IPaddress[5] = ''; // IP-адрес 5

		userValue_IPaddress[6] = ''; // IP-адрес 6
		userDesc_IPaddress[6] = ''; // IP-адрес 6

		userValue_IPaddress[7] = ''; // IP-адрес 7
		userDesc_IPaddress[7] = ''; // IP-адрес 7

		userValue_IPaddress[8] = ''; // IP-адрес 8
		userDesc_IPaddress[8] = ''; // IP-адрес 8

		userValue_IPaddress[9] = ''; // IP-адрес 9
		userDesc_IPaddress[9] = ''; // IP-адрес 9

		// IP-адрес, устанавливаемый в списке доступных IP-адресов по умолчанию
		// если переменная userIPaddressDefault='', по умолчанию становиться адрес '192.168.1.250'
		userIPaddressDefault = ''; // IP-адрес: номер по умолчанию (от 0 до 9)

	// end ##### СПИСОК IP-АДРЕСОВ



	// ##### СПИСОК РАЗРЕШЕНИЯ ФОРМИРОВАНИЯ СИГНАЛА ТРЕВОГИ ПРИ ВКЛЮЧЕНИИ ВЫХОДА/ВЫХОДОВ ИЛИ ФЛАГА/ФЛАГОВ

		// 0 - формирование сигнала тревоги запрещено;
		// 1 - формирование сигнала тревоги разрешено;
		userSound_Out[0] = 0; // вход 0
		userSound_Out[1] = 0; // вход 1
		userSound_Out[2] = 0; // вход 2
		userSound_Out[3] = 0; // вход 3
		userSound_Out[4] = 0; // вход 4
		userSound_Out[5] = 0; // вход 5

		userSound_Flag[0] = 0; // флаг 0
		userSound_Flag[1] = 0; // флаг 1
		userSound_Flag[2] = 0; // флаг 2
		userSound_Flag[3] = 0; // флаг 3
		userSound_Flag[4] = 0; // флаг 4
		userSound_Flag[5] = 0; // флаг 5

	// end ##### СПИСОК РАЗРЕШЕНИЯ ФОРМИРОВАНИЯ СИГНАЛА ТРЕВОГИ ПРИ ВКЛЮЧЕНИИ ВЫХОДА/ВЫХОДОВ ИЛИ ФЛАГА/ФЛАГОВ



	// ##### СПИСОК МАКРОСОВ

		// если переменная userValue_Macro[х]='', макрос на отправляется
		userValue_Macro[0] = 'out0_ctrl=1&out1_ctrl=1&out2_ctrl=1'; // макрос 0: содержание запроса
		userDesc_Macro[0] = 'Включить<br>ВЫХОДЫ 1,2,3'; // макрос 0: описание (например: "Вкл. выход 1,2,3")

		userValue_Macro[1] = 'out0_ctrl=0&out1_ctrl=0&out2_ctrl=0'; // макрос 1
		userDesc_Macro[1] = 'Отключить<br>ВЫХОДЫ 1,2,3'; // макрос 1

		userValue_Macro[2] = ''; // макрос 2
		userDesc_Macro[2] = 'Макрос<br>не определен'; // макрос 2

		userValue_Macro[3] = ''; // макрос 3
		userDesc_Macro[3] = 'Макрос<br>не определен'; // макрос 3

		userValue_Macro[4] = ''; // макрос 4
		userDesc_Macro[4] = 'Макрос<br>не определен'; // макрос 4

		userValue_Macro[5] = 'out0_ctrl=1&out1_ctrl=1&out2_ctrl=1&out3_ctrl=1&out4_ctrl=1&out5_ctrl=1'; // макрос 5
		userDesc_Macro[5] = 'Включить<br>все ВЫХОДЫ'; // макрос 5

		userValue_Macro[6] = 'out0_ctrl=0&out1_ctrl=0&out2_ctrl=0&out3_ctrl=0&out4_ctrl=0&out5_ctrl=0'; // макрос 6
		userDesc_Macro[6] = 'Отключить<br>все ВЫХОДЫ'; // макрос 6

	// end ##### СПИСОК МАКРОСОВ

	}



// ##### !!!!! КОД НИЖЕ НЕ МЕНЯТЬ !!!!!
	userSettingsRefresh(); // обновление значений и описаний
}



